Loading...
Searching...
No Matches
DcmAttributeTag Class Reference

a class representing the DICOM value representation 'Attribute Tag' (AT) More...

Inheritance diagram for DcmAttributeTag:

## Public Member Functions

| DcmAttributeTag (const DcmTag &tag)
| constructor.
| DcmAttributeTag (const DcmAttributeTag &old)
| copy constructor
virtual | ~DcmAttributeTag ()
| destructor
DcmAttributeTag & | operator= (const DcmAttributeTag &obj)
| assignment operator
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type.
virtual DcmObject * | clone () const
| clone method
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying.
virtual DcmEVR | ident () const
| get element type identifier
virtual OFCondition | checkValue (const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print element to a stream.
OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format
virtual OFCondition | getTagVal (DcmTagKey &tagVal, const unsigned long pos=0)
| get particular tag value
virtual OFCondition | getUint16Array (Uint16 *&uintVals)
| get reference to stored integer data.
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get specified value as a character string.
virtual OFCondition | putTagVal (const DcmTagKey &tagVal, const unsigned long pos=0)
| set particular tag value
virtual OFCondition | putUint16Array (const Uint16 *uintVals, const unsigned long numUints)
| set element value to given integer array data.
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string.
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string.
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching.
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmElement (const DcmElement &old)
| copy constructor
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| This function writes this element's value to the outstream which was passed.
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures
virtual OFCondition | clear ()
| clear (remove) attribute value
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8.
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16.
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16.
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32.
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32.
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32.
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64.
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64.
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64.
virtual OFCondition | getOFStringArray (OFString &value, OFBool normalize=OFTrue)
| get entire element value as a character string.
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16.
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32.
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32.
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32.
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64.
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64.
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64.
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object).
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued).
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value.
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value.
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value.
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value.
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value.
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value.
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value.
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value.
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued).
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued).
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued).
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued).
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued).
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued).
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued).
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued).
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it.
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it.
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file.
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again.
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image.
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object.
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching.
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching.
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise.
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
virtual void | transferEnd (void)
| finalize the transfer state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
virtual DcmItem * | getParentItem ()
| get parent item of this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet)
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Static Public Member Functions

static OFCondition | checkStringValue (const OFString &value, const OFString &vm="1-n")
| check whether given string value conforms to the VR "AT" (Attribute Tag) and to the specified VM.
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR)
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR)
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM)
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string.
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM)

## Protected Member Functions

| DcmAttributeTag (const DcmTag &tag, const Uint32 len)
| constructor.
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value.
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value.
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size.
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this.
virtual void | postLoadValue ()
| performs clean-up functions after loading an attribute value into main memory.
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array.
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field

## Friends

class | DcmItem

## Additional Inherited Members

Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM value representation 'Attribute Tag' (AT)

## Constructor & Destructor Documentation

## DcmAttributeTag() [1/3]

DcmAttributeTag::DcmAttributeTag | ( | const DcmTag & | tag | ) |

constructor.

Create new element from given tag.

Parameters

  tag | DICOM tag for the new element

Referenced by DcmAttributeTag(), clone(), and operator=().

## DcmAttributeTag() [2/3]

DcmAttributeTag::DcmAttributeTag | ( | const DcmAttributeTag & | old | ) |

copy constructor

Parameters

  old | element to be copied

References DcmAttributeTag().

## DcmAttributeTag() [3/3]

DcmAttributeTag::DcmAttributeTag | ( | const DcmTag & | tag,
|  | const Uint32 | len )

protected

constructor.

Create new element from given tag and length. Only reachable from friend classes since construction with length different from 0 leads to a state with length being set but the element's value still being uninitialized. This can lead to crashes when the value is read or written. Thus the method calling this constructor with length > 0 must ensure that the element's value is explicitly initialized, too. Create new element from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

## Member Function Documentation

## checkStringValue()

OFCondition DcmAttributeTag::checkStringValue | ( | const OFString & | value,
|  | const OFString & | vm = "1-n" )

static

check whether given string value conforms to the VR "AT" (Attribute Tag) and to the specified VM.

Parameters

  value | string value to be checked (possibly multi-valued)
  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

## checkValue()

virtual OFCondition DcmAttributeTag::checkValue | ( | const OFString & | vm = "1-n",
|  | const OFBool | oldFormat = OFFalse )

virtual

check whether stored value conforms to the VR and to the specified VM

Parameters

  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | parameter not used for this VR (only for DA, TM)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

Reimplemented from DcmElement.

## clone()

virtual DcmObject * DcmAttributeTag::clone | ( |  | ) | const

inline virtual

clone method

Returns
  deep copy of this object

Implements DcmObject.

References DcmAttributeTag(), and DcmObject::DcmObject().

## compare()

virtual int DcmAttributeTag::compare | ( | const DcmElement & | rhs | ) | const

virtual

comparison operator that compares the normalized value of this object with a given object of the same type.

The tag of the element is also considered as the first component that is compared, followed by the object types (VR, i.e. DCMTK'S EVR) and the comparison of all value components of the object, preferably in the order declared in the object (if applicable).

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if this element has fewer components than the rhs element. Also -1 if the value of the first component that does not match is lower in this object than in rhs. Also returned if rhs cannot be casted to this object type or both objects are of different VR (i.e. the DcmEVR returned by the element's ident() call are different). 1 if either this element has more components than the rhs element, or the first component that does not match is greater in this object than in rhs object.

Implements DcmElement.

References DcmElement::DcmElement().

## copyFrom()

virtual OFCondition DcmAttributeTag::copyFrom | ( | const DcmObject & | rhs | ) |

virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmElement.

References DcmObject::DcmObject().

## getNumberOfValues()

virtual unsigned long DcmAttributeTag::getNumberOfValues | ( |  | ) |

virtual

get number of values stored in this element

Returns
  number of values in this element

Implements DcmObject.

## getOFString()

virtual OFCondition DcmAttributeTag::getOFString | ( | OFString & | stringVal,
|  | const unsigned long | pos,
|  | OFBool | normalize = OFTrue )

virtual

get specified value as a character string.

The output format is "(gggg,eeee)" where "gggg" is the hexa-decimal group number and "eeee" the hexa-decimal element number of the attribute tag.

Parameters

  stringVal | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | not used

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## getTagVal()

virtual OFCondition DcmAttributeTag::getTagVal | ( | DcmTagKey & | tagVal,
|  | const unsigned long | pos = 0 )

virtual

get particular tag value

Parameters

  tagVal | reference to result variable (cleared in case of error)
  pos | index of the value to be retrieved (0..vm-1)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## getUint16Array()

virtual OFCondition DcmAttributeTag::getUint16Array | ( | Uint16 *& | uintVals | ) |

virtual

get reference to stored integer data.

The array entries with an even-numbered index contain the group numbers and the odd entries contain the element numbers (see "putUint16Array()"). The number of entries is twice as large as the return value of "getVM()".

Parameters

  uintVals | reference to result variable

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## getVM()

virtual unsigned long DcmAttributeTag::getVM | ( |  | ) |

virtual

get value multiplicity

Returns
  number of tag value pairs (group,element)

Implements DcmObject.

## ident()

virtual DcmEVR DcmAttributeTag::ident | ( |  | ) | const

virtual

get element type identifier

Returns
  type identifier of this class (EVR_AT)

Implements DcmObject.

## isUniversalMatch()

virtual OFBool DcmAttributeTag::isUniversalMatch | ( | const OFBool | normalize = OFTrue,
|  | const OFBool | enableWildCardMatching = OFTrue )

virtual

Determine if this element is universal matching.

Parameters

  normalize | normalize each element value. Defaults to OFTrue.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  returns OFTrue if element is empty or if enableWildCardMatching is enabled and the element contains only wildcard characters. Returns OFFalse otherwise.

Reimplemented from DcmElement.

## operator=()

DcmAttributeTag & DcmAttributeTag::operator= | ( | const DcmAttributeTag & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

References DcmAttributeTag().

## print()

virtual void DcmAttributeTag::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0,
|  | const int | level = 0,
|  | const char * | pixelFileName = NULL,
|  | size_t * | pixelCounter = NULL )

virtual

print element to a stream.

The output format of the value is a backslash separated sequence of group and element value pairs, e.g. "(0008,0020)\‍(0008,0030)"

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used
  pixelCounter | not used

Implements DcmObject.

## putString() [1/2]

virtual OFCondition DcmAttributeTag::putString | ( | const char * | stringVal | ) |

virtual

set element value from the given character string.

The input string is expected to be a backslash separated sequence of attribute tags, e.g. "(0008,0020)\‍(0008,0030)". This is the same format as used by "print()".

Parameters

  stringVal | input character string

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## putString() [2/2]

virtual OFCondition DcmAttributeTag::putString | ( | const char * | stringVal,
|  | const Uint32 | stringLen )

virtual

set element value from the given character string.

The input string is expected to be a backslash separated sequence of attribute tags, e.g. "(0008,0020)\‍(0008,0030)". This is the same format as used by "print()". The length of the string has to be specified explicitly. The string can, therefore, also contain more than one NULL byte.

Parameters

  stringVal | input character string
  stringLen | length of the string (number of characters without the trailing NULL byte)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## putTagVal()

virtual OFCondition DcmAttributeTag::putTagVal | ( | const DcmTagKey & | tagVal,
|  | const unsigned long | pos = 0 )

virtual

set particular tag value

Parameters

  tagVal | tag value to be set
  pos | index of the value to be set (0 = first position)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## putUint16Array()

virtual OFCondition DcmAttributeTag::putUint16Array | ( | const Uint16 * | uintVals,
|  | const unsigned long | numUints )

virtual

set element value to given integer array data.

The array entries with an even-numbered index are expected to contain the group numbers and the odd entries to contain the element numbers, e.g. {0x0008, 0x0020, 0x0008, 0x0030}. This function uses the same format as "getUint16Array()".

Parameters

  uintVals | unsigned integer data to be set
  numUints | number of integer values to be set (should be even)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## verify()

virtual OFCondition DcmAttributeTag::verify | ( | const OFBool | autocorrect = OFFalse | ) |

virtual

check the currently stored element value

Parameters

  autocorrect | correct value length if OFTrue

Returns
  status, EC_Normal if value length is correct, an error code otherwise

Implements DcmObject.

## writeJson()

virtual OFCondition DcmAttributeTag::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format )

virtual

write object in JSON format

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## writeXML()

OFCondition DcmAttributeTag::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0 )

virtual

write object in XML format

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcvrat.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0